<template>
    <div @click="showModal">
        <slot></slot>
        <modal v-model="isModalOpen" :footer="false">
            <slot name="form" :events="{ put }" :data="{ loading }"></slot>
        </modal>
    </div>
</template>

<script lang="ts">
    import BaseCrudBtn from '../../common/crud/BaseCrudBtn'
    import Component from 'vue-class-component'
    import PutInterface from '../../../interfaces/common/crud/PutInterface'

    @Component({})
    export default class EditBtn extends BaseCrudBtn implements PutInterface {
        put(entity) {
            this.loading = true

            this.http.put(
                `${this.route}/${entity.id}`,
                entity,
                (res) => {
                    this.$emit('success', res)
                    this.loading = false
                    this.alert.success('Success')
                    this.closeModal()
                },
                (err) => {
                    this.$emit('error', err)
                    this.alert.error('Error')
                }
            )
        }
    }
</script>